import java.io.*;
import java.net.*;
import java.security.*;
import iaik.security.rsa.*;

				//   Classe del Thread per il caricamento di Agenti esterni.  
				//   E' di uso interno  (richiamato da Negoziatore).

				 //  @author	                  Matteo Fasanella

class AgentLoader extends Thread{
	int timeOut = 60000;                      //  TimeOut
	int port;
	byte[] publicKey = new byte[789];
	byte[] simmKey  = new byte[Negoziatore.simmKeyLen];
	boolean delayed = false;
	int priority = 0;
	byte[] risorse = new byte[32];
	
	
	public AgentLoader(int portaNeg, byte[] publicKey, byte[] simmKey, boolean delayed, int priority, byte[] risorse)  {
		port = portaNeg;
		publicKey = this.publicKey;
		simmKey  = this.simmKey;
		delayed = this.delayed;
		priority = this.priority;
		risorse = this.risorse;
	}
	
	public void run()  {
		byte[] loadPacket;    // contiene informazioni utili per il caricamento dell'Agente
				              // tra le quali: metodo da riattivare e URL remota
		
		DatagramSocket door = null;  
		
		try {
              		door = new DatagramSocket( port );
		     	DatagramPacket recvPacket = new DatagramPacket ( new byte[Negoziatore.cryptedPacketLen], Negoziatore.cryptedPacketLen);
		     	door.setSoTimeout(timeOut/1000);
		     	door.receive(recvPacket);
		     	loadPacket = cryptoPrimitive.decypher (recvPacket.getData(), new iaik.security.cipher.SecretKey(simmKey, "RAW"));
		} catch (InterruptedIOException ex) { 
			Negoziatore.numThreads -=1;
			AgentresManager.rilasciaRisorse( publicKey);          
			Negoziatore.setFreePort(port, Negoziatore.myPublicKey);
  	              	return;
		} catch (Exception e) {}
           	
        		if (delayed == false) {
        			try{
        				AgentID agentID;
/*           			byte[] cryptAgent;			// qui Carica, Decritta e mette in esecuzione l'Agente
           			byte[] Agent;				//  ovviamente sotto il controllo dell'Access Controller
           			
           			cryptAgent = loadAgent(loadPacket);   // prende l'URL da loadPacket
           			Agent = decypher (cryptAgent, simmKey);
				execAgent (Agent, loadPacket, priority);    // prende il metodo da riattivare da loadPacket           			
*/				
				int uniqueID = Negoziatore.nextUnique();
				Negoziatore.addUnique (uniqueID, agentID);    // crea una entry nella tabella UniqueID - AgentID
				
				RSAPublicKey key=null;
				try {
				       ByteArrayInputStream instream = new ByteArrayInputStream(publicKey);
				       ObjectInputStream p = new ObjectInputStream(instream);
				       key = (RSAPublicKey) p.readObject();
				       instream.close();      
				} catch (Exception e) {  }
				
				logManager.appendRecord ( key, uniqueID,  0, (byte) 1, Negoziatore.getTime(), null);
         			
         			door.close();
         			Negoziatore.setFreePort (port,  Negoziatore.myPublicKey);
         		} catch (Exception e) { }
           	}
           	else {    // caricamento delayed
           	}
           	
	}

}