import java.security.*;
import java.io.*;
import iaik.utils.*;

				//   Classe per la gestione dei file Agent.res e Agent.res.default.   
				//   (ad uso interno)

				 //  @author	                  Matteo Fasanella

public class AgentresManager {
	final static int fileLen = 801;


	public static synchronized int appendRecord ( Key publicKey, int minMem, byte cpu, byte nmaxAgents, int costo, byte nmaxPorte, byte nmaxAlias) {
		long pos;					// per es per un agente nuovo (o per le politiche di default)
		
		try {
			
		       byte[] serializedKey;
		       ByteArrayOutputStream baos = new ByteArrayOutputStream();
		       ObjectOutputStream oos = new ObjectOutputStream (baos);
		       oos.writeObject (publicKey);
		       serializedKey = baos.toByteArray();
		       
		        RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");
		        pos = p.length();
		        p.seek( pos );
		        p.write(serializedKey);
		        p.writeInt(minMem);
		        p.writeByte(cpu);
		        p.writeByte(nmaxAgents);
		        p.writeInt(costo);
		        p.writeByte(nmaxPorte);
		        p.writeByte(nmaxAlias);
		        p.close();       
		} catch (Exception e) { System.out.println ("eccezione: " + e.toString()); return -1;}
		
		Negoziatore.addAgentres ( publicKey, (pos/fileLen) );
		
		return 0;
	}
	
	public static byte[] searchKey (Key key) {
		
		byte[] ritorno = new byte[12]; //   min in mem, %cpu, nmaxAgents, costo, nmaxPorte, nmaxAlias
		ritorno[0] = -1;
		
		long pos = Negoziatore.searchAgentres(key);
		System.out.println("key at pos: "+ pos);
		if ( pos == -1 ) return ritorno;

		byte[] serializedKey = new byte[789];
		
	   try{	
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ObjectOutputStream oos = new ObjectOutputStream (baos);
		oos.writeObject (key);
		serializedKey = baos.toByteArray();
		       
		byte[] serializedFileKey = new byte[789];
  	          RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");	     	

	          p.seek(789 + (pos * fileLen) );
	          System.out.println(" seek at: "+ (789+(pos*fileLen)) );
  		   
		int ret = p.readInt();
		ritorno[0] = 00;  			// min in memoria come:     00|08|64|00 per 86400 (il max)
		ritorno[3] = (byte) (ret % 100);               ret = ret / 100;
		ritorno[2] = (byte) (ret % 100);     	   ret = ret / 100;
		ritorno[1] = (byte) ret;
		
		ritorno[4] = p.readByte();  		// % CPU
		System.out.println("%CPU: "+ ritorno[4]);
		ritorno[5] = p.readByte();  		// Nmax Agenti
		System.out.println("maxAgents: "+ ritorno[5]);		
		
		ret = p.readInt();				// costo come:   1|00|00|00 per 1.000.000 (valore max)
		ritorno[6] = (byte) (ret % 100);                  ret = ret / 100;
		ritorno[7] = (byte) (ret % 100);                  ret = ret / 100;
		ritorno[8] = (byte) (ret % 100);                  ret = ret / 100;
		ritorno[9] = (byte) ret;			
		
		ritorno[10] = p.readByte();
		ritorno[11] = p.readByte();
         	p.close();
		return ritorno;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return ritorno; }
	}
	

	
	public static synchronized int deleteAlias (int alias) {   // da Vedere
	
		long pos = Negoziatore.searchLog (alias);
		if (pos == -1) return -1;
		
		Negoziatore.delLog (alias);
		try {
  	            RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");
	        	    
		    p.seek(793 + (pos * fileLen) );
		    p.writeInt(-1);                                   //   -1  <=>  niente Alias
	             
	             p.close();
	             return 0;
  		  }  catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}
	
	public static synchronized int incAgents (Key key) {   
	
		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return -1;
		
	   try{	
  	         RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");	     	

	         p.seek(794 + (pos * fileLen) );
	         byte numAgents = p.readByte();
	         p.seek(794 + (pos * fileLen) );	         
		p.writeByte(numAgents + 1);
         	p.close();
         	
		return 0;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}

	public static synchronized int decAgents (Key key) {
	
		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return -3;                  //  Agent not found   (key)
		
	   try{	
  	         RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");	     	

	         p.seek(794 + (pos * fileLen) );
	         byte numAgents = p.readByte();
	         if (numAgents == 0) { p.close(); return -1;  }
        	         p.seek(794 + (pos * fileLen) );
		p.writeByte(numAgents-1);
         	p.close();
         	
		return 0;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}


	public static synchronized int updateCPU (Key key, byte cpu) {
	
		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return -1;
		
	   try{	
  	         RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");	     	

	         p.seek(793 + (pos * fileLen) );
		p.writeByte(cpu);
         	p.close();
         	
		return 0;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}


	public static synchronized int updateMinMem (Key key, int minMem) {   // per reinizializzare il contatore
	
		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return -1;
		
	   try{	
  	         RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");	     	

	         p.seek(789 + (pos * fileLen) );
		p.writeInt(minMem);
         	p.close();
         	
		return 0;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}


	public static synchronized int decMinMem (Key key) {   
	
		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return -3;
		
	   try{	
  	         RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");	     	

	         p.seek(789 + (pos * fileLen) );
	         int minMem = p.readInt();
	         if (minMem <= 1) {  p.close();  return -1;  }
	         p.seek(789 + (pos * fileLen) );	         
		p.writeInt(minMem/2);
         	p.close();
         	
		return 0;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}

	public static synchronized int decMem (Key key, int meno) {   
	
		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return -3;
		
	   try{	
  	         RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");	     	

	         p.seek(789 + (pos * fileLen) );
	         int minMem = p.readInt();
	         if ( (minMem - meno) <= 1) {  p.close();  return -1;  }
	         p.seek(789 + (pos * fileLen) );	         
		p.writeInt( (minMem-meno) );
         	p.close();
         	
		return 0;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}

	public static synchronized int incMinMem (Key key) {   
	
		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return -3;
		
	   try{	
  	         RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");	     	

	         p.seek(789 + (pos * fileLen) );
	         int minMem = p.readInt();
	         p.seek(789 + (pos * fileLen) );	         
		p.writeInt(minMem*2);
         	p.close();
         	
		return 0;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}


	public static synchronized int decNmaxPorte (Key key) {
	
		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return -1;
		
	   try{	
  	         RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");	     	

	         p.seek(799 + (pos * fileLen) );
	         byte numPorte = p.readByte();
	         if (numPorte == 0 ) { p.close(); return -1; }
	         p.seek(799 + (pos * fileLen) );	         
		p.writeByte(numPorte-1);
         	p.close();
         	
		return 0;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}

	public static synchronized int incNmaxPorte (Key key, byte nmaxPorte) {
	
		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return -3;
		
	   try{	
  	         RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");	     	


	         p.seek(799 + (pos * fileLen) );
	         byte numPorte = p.readByte();
	         p.seek(799 + (pos * fileLen) );
		p.writeByte(nmaxPorte+1);
         	p.close();
         	
		return 0;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}



	public static synchronized int decNmaxAlias (Key key) {
	
		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return -3;
		
	   try{	
  	         RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");	     	

	         p.seek(800 + (pos * fileLen) );
	         byte numAlias = p.readByte();
	         if (numAlias  == 0 ) { p.close(); return -1; }
	         p.seek(800 + (pos * fileLen) );	         
		p.writeByte(numAlias-1);
         	p.close();
         	
		return 0;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}


	public static synchronized int incNmaxAlias (Key key) {
	
		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return -3;
		
	   try{	
  	         RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");	     	

	         p.seek(800 + (pos * fileLen) );
	         byte numAlias = p.readByte();
	         if (numAlias  == 0 ) { p.close(); return -1; }
	         p.seek(800 + (pos * fileLen) );
		p.writeByte(numAlias+1);
         	p.close();
         	
		return 0;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}
	
	public static synchronized byte[] impegnaRisorse( byte[] sKey) {
		Key key;
		
		byte[] ritorno = new byte[32]; //   formato del PacchettoRisposta
		ritorno[0] = -3;
	
		try {
		    ByteArrayInputStream istream = new ByteArrayInputStream(sKey);
	            ObjectInputStream ois = new ObjectInputStream(istream);
	            key = (Key) ois.readObject();
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return ritorno; }


		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return ritorno;
		ritorno[0] = -1;

		if ( decMinMem(key) != 0) return ritorno;
		if ( decAgents(key) != 0) return ritorno;		
		
	
		byte[] agentres = searchKey (key);
		byte[] agentlog = logManager.searchKey (key);
		
		ritorno[0] = agentres[0];   // min in mem
		ritorno[1] = agentres[1];  		
		ritorno[2] = agentres[2];  
		ritorno[3] = agentres[3];  
		
		ritorno[4] = agentres[10];    // numMax porte
		
		ritorno[5] = agentres[4];  	// % CPU
		
		ritorno[6] = agentres[5];     // numMax Agents
		
		ritorno[7] = agentres[6];     // costo
		ritorno[8] = agentres[7];  						
		ritorno[9] = agentres[8];  
		ritorno[10] = agentres[9];  
		
		if ( agentlog[0] == -1) {
			ritorno[11] = 0;                     // num Agenti presenti
			ritorno[12] = -1;			// last Access
			ritorno[13] = -1;
			ritorno[14] = 0;			// delayed
		} else {
			ritorno[11] = agentlog[0];                     // num Agenti presenti
			ritorno[12] = agentlog[1];			// last Access
			ritorno[13] = agentlog[2];			
			ritorno[14] = 0;					// delayed
		}
		
		return ritorno;
	}		


	public static synchronized void rilasciaRisorse( byte[] sKey) {
		Key key;
		
		try {
		    ByteArrayInputStream istream = new ByteArrayInputStream(sKey);
	            ObjectInputStream ois = new ObjectInputStream(istream);
	            key = (Key) ois.readObject();
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return ; }


		long pos = Negoziatore.searchAgentres( key);
		if (pos == -1) return ;

		incMinMem(key);
		incAgents(key);		
	}		


	public static byte[] readDefault () {             // per gli Agenti nuovi
		
		byte[] ritorno = new byte[12]; //   min in mem, %cpu, nmaxAgents, costo, nmaxPorte, nmaxAlias
		ritorno[0] = -1;
		
	   try{	
  	          RandomAccessFile p = new RandomAccessFile ("Agent.res.default", "rw");	     	

	         p.seek(0);
		int ret = p.readInt();
		ritorno[0] = 00;  			// min in memoria come:     00|08|64|00 per 86400 (il max)
		ritorno[3] = (byte) (ret % 100);               ret = ret / 100;
		ritorno[2] = (byte) (ret % 100);     	   ret = ret / 100;
		ritorno[1] = (byte) ret;
		
		ritorno[4] = p.readByte();  		// % CPU
		System.out.println("%CPU: "+ ritorno[4]);
		ritorno[5] = p.readByte();  		// Nmax Agenti
		System.out.println("maxAgents: "+ ritorno[5]);		
		
		ret = p.readInt();				// costo come:   1|00|00|00 per 1.000.000 (valore max)
		ritorno[6] = (byte) (ret % 100);                  ret = ret / 100;
		ritorno[7] = (byte) (ret % 100);                  ret = ret / 100;
		ritorno[8] = (byte) (ret % 100);                  ret = ret / 100;
		ritorno[9] = (byte) ret;			
		
		ritorno[10] = p.readByte();
		ritorno[11] = p.readByte();
         	p.close();
		return ritorno;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return ritorno; }
	}


}