import java.io.*;
import java.net.*;
import java.lang.Integer;
import java.lang.Number;
import java.util.Hashtable;
import java.security.*;
import iaik.security.rsa.*;

               // Classe dedicata alla Negoziazione (per l'ingresso di Agenti nel Place)
               // e alla gestione dei messaggi relativi ad un Alias di MaiBox

               //  @author	                  Matteo Fasanella


class Negoziatore extends Thread{
	
              public static int numThreads = 0;  // modificata da AgentLoader e dal Loader della versione precedente
              private DatagramSocket bridge = null;           // Socket per la Negoziazione
              static boolean[]  port = new boolean[1111];	                               // lista di porte occupate	
              private static int startPort = 55555;   // Si assume come default la porta 55555 (Porta Negoziazione)
              static RSAPrivateKey   myPrivateKey;                  // chiave privata del Place
              public static RSAPublicKey   myPublicKey;                  // chiave pubblica del Place              
              public static byte[] mySign;
              static boolean acceptUnknown = false;
              static int lastUnique = 0;
              static int lastAlias = 0;
                            
              static final int cryptedPacketLen=0, cryptedRetPacketLen = 0;
              static final  int signLen=0, simmKeyLen = 0;

              
              private static Hashtable logHash = new Hashtable();
              private static Hashtable logKeyHash = new Hashtable();              
              private static Hashtable AgentresHash = new Hashtable();
              private static Hashtable uniqueHash = new Hashtable();
              private static Hashtable portHash = new Hashtable();
	     private static Hashtable unkeyHash = new Hashtable();	              
               
              public Negoziatore()  {
              	
              	initPort();
              	initLog();
		initAgentres();      
	        myPrivateKey = getPlacePrivateKey();		
	        myPublicKey = getPlacePublicKey();	
	        mySign = cryptoPrimitive.sign ( toByteArray(myPublicKey), myPrivateKey);		        
              	
              	try {
              		 bridge = new DatagramSocket( startPort );
              		// Socket dedicata alla Negoziazione. 
              		port[0] = true;
              	} catch (SocketException SE) {
              		System.out.println("Errore Apertura Socket di Negoziazione: " + SE);
              		return ;
           	}
           	
       		Thread Gest = new Gestore( 30 );          //  30 minuti tra un controllo e l'altro......
       		Gest.start();   

              }
              
/*             public Negoziatore(int port)  {          // per specificare un insieme di porte diverso dal Default
             	startPort = port;		// NB: il Negoziatore usa 1111 porte a partire da startPort
             	Negoziatore();		// NB: Tutti i Places devono usare lo stesso insieme di porte
             }
*/
              
              
              public void run()  {
              	
              	byte[] recvPacket = new byte[2048];
              	
              	DatagramPacket sendPacket = new DatagramPacket ( new byte[cryptedRetPacketLen], cryptedRetPacketLen);
              	// Si assume che i pacchetti di ritorno verso l'Agente siano di 32 Byte
              	
	     	DatagramPacket cryptedPacket = new DatagramPacket ( new byte[cryptedPacketLen], cryptedPacketLen);
	   	// Si assume che i Pacchetti di Negoziazione siano di 2048 Byte


              	
              	for (;;) {
               		
              		try {
              			bridge.receive(cryptedPacket);
	              		while ( (  cryptedPacket.getLength()) != cryptedPacketLen) { bridge.receive(cryptedPacket); }
	              	} catch (Exception SE) {
	              		System.out.println ("Errore sulla Socket di Negoziazione: " + SE.toString());  
	              	}
	              		
              		recvPacket = cryptoPrimitive.decypher(cryptedPacket.getData(), myPrivateKey);
              		
              		byte publicKey[] = new byte[789];
              		for (int i=0; i<=788; i++) publicKey[i] = recvPacket[i];
              		RSAPublicKey key=null;
			try {
			       ByteArrayInputStream instream = new ByteArrayInputStream(publicKey);
			       ObjectInputStream p = new ObjectInputStream(instream);
			       key = (RSAPublicKey) p.readObject();
			       instream.close();      
			} catch (Exception e) {  }
			
              		byte sign[] = new byte[signLen];
              		for (int i=0; i<=signLen; i++) sign[i] = recvPacket[789+i];

              		if (! cryptoPrimitive.verify(publicKey, sign, myPrivateKey))    // controlla se le credenziali non sono valide
              			continue;
              		
              		byte simmKey[] = new byte[simmKeyLen];
              		for (int i=2047-simmKeyLen; i<=2047; i++) simmKey[i] = recvPacket[i-(2047-simmKeyLen)];
              		
              		byte flagB[] = new byte[4];
              		for (int i=1; i<=4; i++) flagB[i] = recvPacket[i+788+signLen];
              		int flag = flagB[0] + flagB[1]*100 + flagB[2]*10000 + flagB[3]*1000000;
              		
              		
		if (flag == 0) {   // Negoziazione Normale

										    // incrementa i contatori per l'Agente che arriver
				byte[] risorse = AgentresManager.impegnaRisorse(publicKey);
				if (risorse[0] == -3)  {
					if (acceptUnknown) 	risorse = AgentresManager.readDefault();
					else continue;
				}
				if (risorse[0] == -1) continue;   // in realt dovrei controllare se usare caricamento delayed
				
              			int portaNeg = getFreePort( myPublicKey, mySign);    // anche il Server deve essere presente nel file Agent.res
              			sendPacket = makeReplyPacket( cryptedPacket.getAddress(), cryptedPacket.getPort(), simmKey, portaNeg, risorse);   // crea il pacchetto di risposta
              			try {
	              			bridge.send(sendPacket);
	              		} catch (Exception e) { 	System.out.println ("Errore sulla Socket di Negoziazione: " + e.toString());   }

				numThreads = numThreads +1;
	              		
	              		boolean delayed = false;
	              		int priority = (risorse[5] *numThreads) % 10;
	              		Thread AL = new AgentLoader(portaNeg, publicKey, simmKey, delayed, priority, risorse);
	              		AL.start();   // aspetta la richiesta sulla porta portaNeg, e carica l'agente
	              		// AgentLoad deve fare la setFreePort
	              		
              		}     // End   (flag == 0)
              		else {                                     //  Gestione Alias di MailBox
              			int alias = recvPacket[788+signLen] + recvPacket[788+signLen+1]*100 + recvPacket[788+signLen+2] *10000 +recvPacket[788+signLen+3] *1000000;              		
              			int addNextAlias = recvPacket[788+signLen+17] + recvPacket[788+signLen+18]*100 + recvPacket[788+signLen+19] *10000 +recvPacket[788+signLen+20] *1000000;              		;
              			
              			if (addNextAlias !=0)  logManager.addNextAlias (alias, addNextAlias);
              			else {
              				
		              	if(! logManager.checkAlias (alias, key) ) continue;
		              	byte[] log = logManager.searchAlias (alias);
		              	byte presente = log[0];
              			if ( presente == 1 )  {
              				int toUnique = log[7] + log[8]*100 + log[9]*10000 + log[10] *1000000 + log[11] * 10000000;
					
              				byte next = recvPacket[788+signLen+4];
              		              	byte from[] = new byte[4];
		              		for (int i=0; i<=3; i++) from[i] = (byte) (recvPacket[788+signLen+5+i]+122);
		              		int fromPort = recvPacket[788+signLen+8] + recvPacket[788+signLen+9]*100 + recvPacket[788+signLen+10] *10000;
              				
              				Thread AM = new AliasManager(from, fromPort, getFreePort(myPublicKey, mySign), simmKey, toUnique, next, alias);
              				AM.start();    // AliasManager prende i dati dalla porta (nextFreePort) 
              					    // e li manda alla MailBox relativa all'Alias
              			}
              			else if (presente !=-1) {
              				byte[] nextAddrB = new byte[4];
              				nextAddrB[0] = log[3];    nextAddrB[1] = log[4];   nextAddrB[2] = log[5];  nextAddrB[3] = log[6];
              			        InetAddress nextAddr = htons ( nextAddrB);
					int nextAlias = log[12] + log[13]*100 + log[14]*10000 + log[15] *1000000;              			        
              			        
					
              			        int ret = commPrimitive.sendMBox ( recvPacket, nextAddr, nextAlias, getFreePort( myPublicKey, mySign), 60000, key, sign, 0);

              			        logManager.deleteAlias(alias);     // cancella il campo alias dal record del Log
              			}      // Si fa il forwarding solo della richiesta
              			}  // chiude l'if su addNextAlias
              		}    
              	}
              	
              	
              }   
              
              
              private int checkCredential (byte[] publicKey, byte[] sign) {
              	
              	return -1;
              }
              
              private void incCounter (byte[] publicKey) {
              }
               
//              private DatagramPacket makeReply(byte[] publicKey, InetAddress address, int port, byte[] simmKey)  {
//              }

//              private byte[] searchAlias (byte[] PublicKey, short AgentID)  {
//              }
        
        	     
        	    private void initPort() {
        	    	
        	    	for ( int i=0; i<= 1110; i++)  port[i] = false;
        	    }
        	     
        	     	
              private static int nextFreePort()  {    // le porte da 55555 a 56666 sono riservate 
              	int i = 1;
              	
              	while ( port[startPort+i] && i<1111)  i++;
              	
              	if ( i==1110 && port[1110] ) return -1;
              	return i;			
              }   		            
              
				               //  getFreePort ritorna la prima porta libera che diventa occupata
               public static int getFreePort(Key key, byte[] sign) {
              	
              	if (! cryptoPrimitive.verify(toByteArray(key), sign, key) ) return -1;
                 if (AgentresManager.decNmaxPorte(key) == -1) return -1;
              	
              	int porta = nextFreePort();
              	if ( porta != -1 )  port[porta] = true;
              	portHash.put(new Integer(porta), key );
              	return porta+startPort;
              }

              public static void setFreePort( int p, Key key) {
              	
              	if (!checkPort(p, key) ) return;
              	port [p-startPort] = false;
              	portHash.remove(new Integer(p-startPort));
              }
              
              
              public static boolean checkPort (int port, Key key) {
              	
              	return ( ( portHash.get(new Integer(port) ))  == key);
              }
              
            			        
               private void	deleteAlias(int alias) {     // cancella il campo alias dal record del Log
               
              }
              
              
              public static long searchLog( int alias) {
              	
              	Long ret = ((Long) logHash.get(new  Integer(alias)));      
              	
              	if (ret == null) return -1;
              	return ret.longValue();
              }
              
               public static long searchLogKey( Key key) {
              	
              	Long ret = ((Long) logKeyHash.get( key ) );      
              	
              	if (ret == null) return -1;
              	return ret.longValue();
              }

              
              public static synchronized long searchAgentres( Key key) {
              	
              	Long ret = ((Long) AgentresHash.get(key) );      
              	
              	if (ret == null) return -1;
              	return ret.longValue();
              }
              
              
             public static synchronized void addLog (int alias, long pos) {  
              	
		logHash.put ( new Integer(alias), new Long(pos));              	
             }
        
             public static synchronized void addLogKey (Key key, long pos) {
              	
		logKeyHash.put ( key, new Long(pos));              	
             }


             public static synchronized void addAgentres (Key key, long pos) {
              	
		AgentresHash.put ( key, new Long(pos));              	
             }
             
            
             public static synchronized void delLog (int alias) {
            
            	logHash.remove ( new Integer(alias) );
            }

             public static synchronized void delLogKey (Key key) {
            
            	logKeyHash.remove ( key );
            }


             public static synchronized void delAgentres (Key key) {
            
            	AgentresHash.remove ( key );
            }
              
             private int initLog()  { 	
   		   byte[] serializedFileKey = new byte[789];
   		   Key fileKey;

              
		try {
  	            RandomAccessFile p = new RandomAccessFile ("log", "rw");
	        	    
	        	     long len = p.length();
		     for ( long i=0;  ((i+1)*804)  <= len;  i++ ) {           
		     	p.seek( (i * 804) );                                   //  per avere l' i-esima Key....
		     	int read = p.read(serializedFileKey );
			ByteArrayInputStream istream = new ByteArrayInputStream(serializedFileKey);
		        ObjectInputStream ois = new ObjectInputStream(istream);
		        fileKey = (Key) ois.readObject();
		        logKeyHash.put ( fileKey, new Long(i));
		     	
		     	p.seek(793 + (i * 804) );                    //  per avere l' i-esimo Alias....
		     	int alias = p.readInt();
		     	if ( alias == -1 ) continue;                  // alias == -1  <=>  niente alias
		     	logHash.put ( new Integer(alias), new Long(i));
		     }
	             
	             p.close();
	             return 0;
  		  }  catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
              }


             private int initAgentres()  { 	
              
		try {
		   fileCopy ("Agent.res.startUp", "Agent.res");			
			
  	            RandomAccessFile p = new RandomAccessFile ("Agent.res", "rw");
   		   byte[] serializedFileKey = new byte[789];
   		   Key fileKey;
	        	    
	        	     long len = p.length();
		     for ( long i=0;  ((i+1)*799)  <= len;  i++ ) {            //  legge tutti i campi Key....
		     	p.seek(1 + (i * 799) );                    //  per avere l' i-esima Key....
		     	
		     	int read = p.read(serializedFileKey );
			ByteArrayInputStream istream = new ByteArrayInputStream(serializedFileKey);
		        ObjectInputStream ois = new ObjectInputStream(istream);
		        fileKey = (Key) ois.readObject();
		     	
		     	AgentresHash.put ( fileKey, new Long(i));
		     }
	             
	             p.close();
	             return 0;
  		  }  catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
              }



	public static synchronized  byte[] searchAgentLog( int uniqueID) {
		
		byte[] ritorno = new byte[3]; //   Present,  Time
		ritorno[0] = -1;

		
	     try {  	          
  	          RandomAccessFile p = new RandomAccessFile ("log", "rw");	     	
  	          long len = p.length();
  	          long pos = ( (len/804) * 804) - 15;
  	          
  	          p.seek(pos );
  	          int agID = p.readInt();
  	          while ( (agID != uniqueID) && ((pos-804)>0) ) {
  	          	pos = pos - 804;
  	          	p.seek (pos);
  	          	agID = p.readInt();
  	          }
  	          if (agID != uniqueID) return ritorno;
  		   
  		p.seek (pos+8);   
		ritorno[0] = p.readByte();  		
		ritorno[1] = p.readByte();
		ritorno[2] = p.readByte();
         	p.close();
		return ritorno;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return ritorno; }

	}

	
             public static synchronized void addUnique (int unique, AgentID agent, Key key) {
              	
		uniqueHash.put ( new Integer(unique), agent);        
		
		Gestore.presenti[unique] = true;   
		unkeyHash.put ( new Integer(unique), key);   	
             }
           
            
             public static synchronized void delUnique (int unique) {
            
            	uniqueHash.remove ( new Integer(unique) );
            	
		Gestore.presenti[unique] = false;      	        
		unkeyHash.remove ( new Integer(unique) );   			
            }

             public static synchronized AgentID searchUnique (int unique) {
             	
              	return ( (AgentID)  uniqueHash.get(new  Integer(unique) )  );      
            }
	
	  public static synchronized Key searchUnkey (int unique) {

              	return ( (Key)  unkeyHash.get(new  Integer(unique) )  );      	  	
	  }
	
           public static synchronized int nextUnique() {
           
           	return ((lastUnique+1)%2000000);	
           }
           
           
           public static int getUnique() {             //  restituisce UniqueID del chiamante
           
           	return -1;
           }

           public static synchronized int nextAlias() {
           
           	return ((lastAlias+1)%2000000);	
           }
           
           
        	private  RSAPrivateKey getPlacePrivateKey() {
	     RSAPrivateKey privateKey = null;		
		
	  try {
	       FileInputStream instream = new FileInputStream("privateKey");
	       ObjectInputStream p = new ObjectInputStream(instream);
	       privateKey = (RSAPrivateKey) p.readObject();
	       instream.close();      
	   } catch (Exception e) { return null; }
	   
	    return privateKey; 
	}

        	private  RSAPublicKey getPlacePublicKey() {
	     RSAPublicKey publicKey = null;		
		
	  try {
	       FileInputStream instream = new FileInputStream("publicKey");
	       ObjectInputStream p = new ObjectInputStream(instream);
	       publicKey = (RSAPublicKey) p.readObject();
	       instream.close();      
	   } catch (Exception e) { return null; }
	   
	    return publicKey; 
	}


	public static byte[] toByteArray (Object obj) {
	
	    byte[] serializedObj = new byte[789];

	    try {		
   		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ObjectOutputStream oos = new ObjectOutputStream (baos);
		oos.writeObject (obj);
		serializedObj = baos.toByteArray();
	    }catch (Exception e) { }
		
	    return serializedObj;
	}


	private static DatagramPacket makeReplyPacket( InetAddress to, int port, byte[] serSimmKey, int portaNeg, byte[] risorse) {   // crea il pacchetto di risposta
		DatagramPacket sendPacket;
		byte[] cryptedData; 
		
		Key simmKey = new iaik.security.cipher.SecretKey(serSimmKey, "RAW");

		risorse [15] = 00;
		risorse [16] = (byte) (port %100);	port =port/100;
		risorse [17] = (byte) (port %100);	port =port/100;
		risorse [18] = (byte) (port);
		
		cryptedData = cryptoPrimitive.cypher(risorse, simmKey);
		
		sendPacket = new DatagramPacket ( cryptedData, cryptedData.length, to, port );
		
		return sendPacket;
	}	


	public static byte[] getTime() {
		byte[] ritorno = new byte[2];
		ritorno[0]=-1;
		
		// vedere la class TimeZone	
		
		return ritorno;
	}

	
	public static InetAddress htons (byte[] byteAddress)  {
		
		return;
	}
	
	
	private static void fileCopy(String source, String dest) {
	
	// copia cource su dest
	
	}
}