import java.security.*;
import java.util.*;
import java.io.*;
import javax.crypto.*;
import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import iaik.utils.*;
import iaik.utils.CryptoUtils;
import iaik.security.provider.IAIK;
import iaik.security.rsa.*;

			//   Primitive crittografiche a disposizione degli Agenti

			 //  @author	                  Matteo Fasanella

public class cryptoPrimitive {
	static RSAPrivateKey    placePrivateKey;
	static RSAPublicKey     placePublicKey;
	static int      rsaKeyLen = 1024, desKeyLen = 24;
	String nullRet = null;
	static byte[] errorB = new byte[1];        // in caso di errore in byte[] torna con byte[0] = -1
//	static IvParameterSpec param ;
	
	
	public cryptoPrimitive () {

	   Security.addProvider(new iaik.security.provider.IAIK());
		
	       placePrivateKey = getPlacePrivateKey();
	       placePublicKey = getPlacePublicKey();
//  	       System.out.println("Place private  key: "+ placePrivateKey.toString());
//  	       System.out.println("Place public   key: "+ placePublicKey.toString());
	       
//    	       Random random = new Random();
//	       byte[] iv = new byte[8];
//	       random.nextBytes(iv); 
//	       param = new IvParameterSpec(iv);

	    errorB[0] = -1;
//	    System.out.println("constructor ok...");
	}
	
	
	public static byte[] cypher( byte[] packet, Key  key)  {
	
	    if ( key == null ) { 
       	   	return cypher ( packet, placePrivateKey); 
                     } else  if ( key.getAlgorithm().compareTo("RSA") == 0  ) {
	   	
	     try {	
//	        System.out.println("RSA coding...");
                         RSAPrivateKey cypherKey = (RSAPrivateKey) key;
                         Cipher rsa = Cipher.getInstance("RSA");
	       rsa.init(Cipher.ENCRYPT_MODE, cypherKey);
	       byte[] encrypted = rsa.doFinal(packet);
	       return encrypted;
	     } catch (Exception ex) {
	        System.out.println("Exception: "+ex.getMessage());
	        return errorB;
	     }
	   } else if ( key.getAlgorithm().compareTo("RAW") ==0  ) {
	   	
	     try {	

	       Key cipherKey = (SecretKey) key;
	       
	       Cipher cipher = Cipher.getInstance("DES/ECB/PKCS5Padding", "IAIK");
	       cipher.init(Cipher.ENCRYPT_MODE, cipherKey);
	       byte[] ciphertext = cipher.doFinal(packet);
	       return ciphertext;
   	     } catch (Exception ex) {
	        System.out.println("Exception: "+ex.getMessage());
	        return errorB;
       	     } 
       	     } else   return errorB;


	}

	public static byte[]  decypher( byte[] packet, Key  key)  {

	    if ( key == null ) { 
       	   	return decypher ( packet, placePublicKey); 
                     } else if ( key.getAlgorithm().compareTo("RSA") == 0  ) {
	     try {	
//	        System.out.println("RSA decoding...");
                         RSAPublicKey decypherKey = (RSAPublicKey) key;
                         Cipher rsa = Cipher.getInstance("RSA");
	       rsa.init(Cipher.DECRYPT_MODE, decypherKey);
	       byte[] decrypted = rsa.doFinal(packet);
	       return decrypted;
	     } catch (Exception ex) {
	        System.out.println("Exception: "+ex.getMessage());
	        return errorB;
	     }
	   } else if ( key.getAlgorithm().compareTo("RAW") ==0  ) {
	   	
	     try {	
	       Key decipherKey = (SecretKey) key;
	       Cipher cipher = Cipher.getInstance("DES/ECB/PKCS5Padding", "IAIK");
	       cipher.init(Cipher.DECRYPT_MODE, decipherKey);
	       byte[] plaintext = cipher.doFinal(packet);
	       return plaintext;
   	     } catch (Exception ex) {
	        System.out.println("Exception: "+ex.getMessage());
	        return errorB;
       	     }
       	   } else   return errorB;

	}

	public static byte[] sign( byte[] packet, Key key)  {

	    if ( key == null ) { 
       	   	return sign ( packet, placePrivateKey); 
                     } else{
	     try {
		Signature sharsa = null;
		sharsa = Signature.getInstance("SHA/RSA", "IAIK");
		sharsa.initSign( (RSAPrivateKey) key);
		
		byte[] shasig = null;
		sharsa.update(packet);
		shasig = sharsa.sign();
		return shasig;
	      } catch (Exception e) {
	           System.out.println("Exception: "+e.getMessage());
	           return errorB;
	      }
	    }
	  }


	public static boolean verify( byte[] packet, byte[] sign, Key key)  {

	    if ( key == null ) { 
       	   	return verify ( packet, sign, placePublicKey); 
                     } else{
	     try {
		Signature sharsa = null;
		sharsa = Signature.getInstance("SHA/RSA", "IAIK");
		
		sharsa.initVerify((RSAPublicKey) key);
		sharsa.update(packet);
		return sharsa.verify(sign);
	      } catch (Exception e) {
	           System.out.println("Exception: "+e.getMessage());
	           return false;
	      }
	  }
	}

	public static Key createKey ()  {

	  try {
	     byte[] key = new byte[desKeyLen];
	    Random random = new Random();
	    random.nextBytes(key);    
	    Key desKey = new iaik.security.cipher.SecretKey(key, "RAW");
	    return desKey;
	   } catch (Exception e) {  
	           System.out.println("Exception: "+e.getMessage());
	           return null;
	   }
	}

	
	private  RSAPrivateKey getPlacePrivateKey() {
	     RSAPrivateKey privateKey = null;		
		
	  try {
	       FileInputStream instream = new FileInputStream("privateKey");
	       ObjectInputStream p = new ObjectInputStream(instream);
	       privateKey = (RSAPrivateKey) p.readObject();
	       instream.close();      
	   } catch (Exception e) { return null; }
	   
//       	    System.out.println (" Place key private loaded...");  		
	    return privateKey; 
	}


	private  RSAPublicKey getPlacePublicKey() {
	     RSAPublicKey publicKey = null;		
		
	  try {
	       FileInputStream instream = new FileInputStream("publicKey");
	       ObjectInputStream p = new ObjectInputStream(instream);
	       publicKey = (RSAPublicKey) p.readObject();
	       instream.close();      
	   } catch (Exception e) { return null; }
	   
//       	    System.out.println (" Place public key loaded...");  		
	    return publicKey; 
	}

}